function f = absparmod2(params)

global data
global fit
global amps
global numTao
global numTaoFixed
global taoFixed
global t
global chisq
global textBox
global absLeftEnd1
global absRightEnd1
global absLeftEnd2
global absRightEnd2
global disperCoeffs
global wavelength
global pulseWidth
%                                  k1        k3       k4  
%fitting according to model:    P* <=> P+BA- -> P+HA- -> 
%                               k0  k2  k01           
% k3 is not fixed 
%param = [ tau1 tau2 tau3  tau4   tau0  tau01 shift];
%           1    2     3    4       5     6

numLam=3;
numK=6;
%k2=param(3)*exp(-param(1)/0.0254);
%k4=param(4)*exp(-param(2)/0.0254);
k=1./params(1:numK);
A=zeros(numLam); 
A(1,1)= -(k(1)+k(5));
A(1,2)= k(2);
A(2,1)= k(1);
A(2,2)=-(k(2)+k(3)+k(6));
%A(2,3)= k(4);
A(3,2)= k(3);
A(3,3)=-k(4); 
%A(3,4)=k(4);
%A(4,4)=-k(5);
A=A*(-1);
[J,L]=eig(A);
Lam=diag(L);
InC=[1;0;0];
X=J\InC;

tTemp = t(absLeftEnd1:absRightEnd1)-t(absLeftEnd1);
tTemp=tTemp';
taoFit=Lam;
shift = polyval(disperCoeffs,wavelength(absLeftEnd2:absRightEnd2)) + params(numK+1) - t(absLeftEnd1);
sigma = pulseWidth/2.355;
datatemp = data(absLeftEnd2:absRightEnd2,absLeftEnd1:absRightEnd1)';
space=zeros(length(tTemp),length(taoFit));
amps=zeros(numLam,absRightEnd2-absLeftEnd2+1);
for i= 1:absRightEnd2-absLeftEnd2+1
  for j = 1:length(taoFit)
    space(:,j) = exp(-taoFit(j)*tTemp).*(1+erf((tTemp-shift(i)+taoFit(j)*sigma^2)/sqrt(2)/sigma))*exp(taoFit(j)*(shift(i)+taoFit(j)*sigma^2/2));
  end
D=diag(X)*J';
V=space*D;
a(:,i) = V\datatemp(:,i);
z(:,i) = V*a(:,i);
end

f = z - datatemp;
fit = z';
amps = a';
chisq = trace(f'*f);
set(textBox,'string',['chisq = ' num2str(chisq)])
drawnow;