function f = spcfun2(params)
%SPC convolution function using "conv" function.

global data
global irf
global weight
global fit
global amps
global numTao
global numTaoFixed
global taoFixed
global t
global chisq
global textBox
global spcLeftEnd
global spcRightEnd

time=t(spcLeftEnd:spcRightEnd);
dataTemp = data(spcLeftEnd:spcRightEnd,:);
irfTemp = irf(spcLeftEnd:spcRightEnd,:);
numPoints = size(dataTemp,1);
numCurves = size(dataTemp,2);
fit = zeros(size(dataTemp));
a = zeros(numTao + numTaoFixed,numCurves);
taoFit = zeros(1,numTao + numTaoFixed);
shift = params(numTao + 1:numTao+numCurves);
taoFit(1,1:numTaoFixed) = taoFixed;
taoFit(1,numTaoFixed+1:numTao + numTaoFixed) = params(1:numTao);
for i= 1:numCurves
    irfTempshift=interp1(time,irfTemp(:,i),time+shift(i));
    temp=isnan(irfTempshift);
    j=find(temp == 1);
    irfTempshift(j)= 0;
    for k=1:length(taoFit)
        R=exp(-time./taoFit(k));%need to change that to get rid of the loop!
        curve(k,:)=conv(irfTempshift,R);%can use conv2 to convolve the irf with the matrix of decays
    end
      curve= curve(:,1:numPoints)';
      a(:,i) = curve\dataTemp(:,i);
      z(:,i) = curve*a(:,i);
end
f = (z - dataTemp)./weight(spcLeftEnd:spcRightEnd,:);
amps = a;
fit=z;
chisq = trace(f'*f)/(numPoints*numCurves-(numTao + numTaoFixed)-(numTao + numTaoFixed)*numCurves-numCurves);
set(textBox,'string',['chisq = ' num2str(chisq)])
drawnow;
